﻿#ifndef JAMMING_H
#define JAMMING_H

#include <QObject>
#include <QUrl>
#include "externalsim.h"
#include "../wsclient/client.h"

struct JammingStyle
{
    double fs;
    double fc;
    QString OpMode;
};

class Jamming : public ExternalSim
{
    Q_OBJECT
public:
    int style;
    std::map<int, JammingStyle> JammingStyleList;
    client *radarsim;
    QThread *radarsimthread;

    void StyleInit();
    explicit Jamming(QObject *parent = nullptr,
                     uint32_t PlatformID = 0, uint32_t InstanceID = 0,
                     bool SwitchMode = false,
                     QString Name = QString::fromLocal8Bit("未知模拟器"),
                     QUrl SimulationUrl = QUrl(QStringLiteral("ws://localhost:1235")),
                     int style = 0);

signals:
    void SigSendStyleToSim(QString newstyle);
public slots:
    void StyleUpdate(int newstyle);

};

#endif // JAMMING_H
