﻿#ifndef RADAR_H
#define RADAR_H

#include <QObject>
#include <QThread>
#include "externalsim.h"
#include "../wsclient/client.h"

struct Style
{
    double fs;
    double fc;
    QString moduType;
    QString PRFMode;
    std::vector<double> PRFs;
    double PulseWidth;
    double BandWidth;
};

class Radar : public ExternalSim
{
    Q_OBJECT

public:
    int style;
    std::map<int, Style> RadarStyleList;
    client *radarsim;
    QThread *radarsimthread;

    explicit Radar(QObject *parent = nullptr,
                   uint32_t PlatformID = 0, uint32_t InstanceID = 0,
                   bool SwitchMode = false,
                   QString Name = QString::fromLocal8Bit("未知模拟器"),
                   QUrl SimulationUrl = QUrl(QStringLiteral("ws://localhost:1235")),
                   int style = 101);
    void StyleInit();
signals:
    void SigSendStyleToSim(QString newstyle);
public slots:
    void StyleUpdate(int newstyle);
};

#endif // RADAR_H
