﻿#ifndef PLATFORM_H
#define PLATFORM_H

#include <QObject>
#include <QTimerEvent>
#include <QDebug>
#include "coordTrans/XYZ2ELL.h"
#include "coordTrans/blh2xyz.h"

class Platform : public QObject
{
    Q_OBJECT
public:
    uint32_t ID;
    QString Name;
    double *x;
    double *y;
    double *z;
    double vx;
    double vy;
    double vz;
    double ax;
    double ay;
    double az;
    double lon;
    double lat;
    double h;
    int TimerUpdatePos;
    explicit Platform(QObject *parent = nullptr, uint32_t ID = 0,
                      QString Name = QString::fromLocal8Bit("未知平台"),
                      double initlon = 120, double initlat = 20, double inith = 8000,
                      double vx = 0, double vy = 0, double vz = 0,
                      double ax = 0, double ay = 0, double az = 0);

    void UpdateAcc(double ax, double ay, double az);
    void UpdateVel(double vx, double vy, double vz);

    void timerEvent(QTimerEvent *event);
signals:

};

#endif // PLATFORM_H
